edButtons[edButtons.length] = new edButton('ed_proofread_bot', 'proofread_bot', '', '', '');

/* convienence method to restore the text area from the preview div */
function proofread_bot_restore_text_area()
{
	/* clear the error HTML out of the preview div */
	proofread_bot.remove('content'); 

	/* swap the preview div for the textarea, notice how I have to restore the appropriate class/id/style attributes */

        var content;

	if (navigator.appName == 'Microsoft Internet Explorer')
		content = jQuery('#content').html().replace(/<BR.*?class.*?proofread_bot_remove_me.*?>/gi, "\n");
	else
		content = jQuery('#content').html();

	jQuery('#content').replaceWith( proofread_bot.content_canvas );
	jQuery('#content').val( content.replace(/\&lt\;/g, '<').replace(/\&gt\;/g, '>').replace(/\&amp;/g, '&') );
	jQuery('#content').height(proofread_bot.height); 

	/* change the link text back to its original label */
	jQuery('#ed_proofread_bot').val( proofread_bot.getLang('button_proofread', 'proofread') );
	jQuery('#ed_proofread_bot').css({ 'color' : '#464646' });

	/* enable the toolbar buttons */
	for (var z = 0; z < edButtons.length; z++)
		if ( edButtons[z].id != 'ed_proofread_bot' )
			jQuery( '#' + edButtons[z].id ).attr('disabled', false);

	jQuery( '#ed_spell' ).attr( 'disabled', false );
	jQuery( '#ed_close' ).attr( 'disabled', false );

	/* restore autosave */
	if (proofread_bot.autosave != undefined)
		autosave = proofread_bot.autosave;
};

/* javascript does some lazy evaluation of function names, have to do the function swap
   this way to make it work as expected */
function proofread_bot_replace_show_function( foo ) {
	var old_button = foo;
	edShowButton = function(button, i) {
		if (button.id == 'ed_proofread_bot') {
			document.write('<input type="button" id="' + button.id + '" accesskey="' + button.access + '" class="ed_button" onclick="proofread_bot_check();" value="' + proofread_bot_l10n_r0ar.button_proofread + '" />');
		} else {
			old_button(button, i);
		}
	}
}

proofread_bot_replace_show_function( edShowButton );

function proofread_bot_restore_if_proofreading() {
	if (jQuery('#ed_proofread_bot').val() == proofread_bot.getLang('button_edit_text', 'edit text')) 
		proofread_bot_restore_text_area();
}

function proofread_bot_unbind_proofreader_listeners() {
	jQuery('#save-post, #post-preview, #publish, #edButtonPreview').unbind('focus', proofread_bot_restore_if_proofreading );
	jQuery('#add_poll, #add_image, #add_video, #add_audio, #add_media').unbind('click', proofread_bot_restore_if_proofreading );
	jQuery('#post').unbind('submit', proofread_bot_restore_if_proofreading );
}

function proofread_bot_bind_proofreader_listeners() {
	jQuery('#save-post, #post-preview, #publish, #edButtonPreview').focus( proofread_bot_restore_if_proofreading );
	jQuery('#add_poll, #add_image, #add_video, #add_audio, #add_media').click( proofread_bot_restore_if_proofreading );
	jQuery('#post').submit( proofread_bot_restore_if_proofreading );
}

/* where the magic happens, checks the spelling or restores the form */
function proofread_bot_check(callback) {

	/* If the text of the link says edit comment, then restore the textarea so the user can edit the text */
	if (jQuery('#ed_proofread_bot').val() == proofread_bot.getLang('button_edit_text', 'edit text')) {                               
		proofread_bot_restore_text_area(); 
	} else {
		/* initialize some of the stuff related to this plugin */
		if (proofread_bot.height == undefined) {

			proofread_bot.height = jQuery('#content').height();
			proofread_bot_bind_proofreader_listeners();

			/* make it so clicking the Visual button works when proofread_bot is active */

			jQuery('#edButtonPreview').attr( 'onclick', null ).click( function() {
				proofread_bot_restore_if_proofreading();
				switchEditors.go( 'content', 'tinymce' );
			});

			/* saved the textarea as we need to restore the original one for the toolbar to continue to function properly */
			proofread_bot.content_canvas = jQuery('#content');

			/* store the autosave, we're going to make it empty during spellcheck to prevent auto saved text from being
			   over written with empty text */
			proofread_bot.autosave = autosave;
		}

		/* set the spell check link to a link that lets the user edit the text */
		jQuery('#ed_proofread_bot').val(proofread_bot.getLang('button_edit_text', 'edit text'));
		jQuery('#ed_proofread_bot').css({ 'color' : 'red' });

		/* disable the button to prevent a race condition where content is deleted if proofread is clicked with a check
		   in progress. */
		jQuery('#ed_proofread_bot').attr('disabled', true); 

		/* replace the div */
		var text = jQuery('#content').val().replace(/\&/g, '&amp;').replace(/\</g, '&lt;').replace(/\>/g, '&gt;');

		if (navigator.appName == 'Microsoft Internet Explorer') {
			text = text.replace(/[\n\r\f]/gm, '<BR class="proofread_bot_remove_me">');
			var node = jQuery('<div class="input" id="content" style="height: 170px">' + text + '</div>');
			jQuery('#content').replaceWith(node);
			node.css( { 'overflow' : 'auto', 'background-color' : 'white', 'color' : 'black' } );
		} else {
			jQuery('#content').replaceWith('<div class="input" id="content">' + text + '</div>');
			jQuery('#content').css( { 'overflow' : 'auto', 'background-color' : 'white', 'color' : 'black', 'white-space' : 'pre-wrap' } );
			jQuery('#content').height(proofread_bot.height); 
		}

		/* kill autosave... :) */
		autosave = function() { };

		/* disable the toolbar buttons */
		for (var z = 0; z < edButtons.length; z++)
			if ( edButtons[z].id != 'ed_proofread_bot' )
				jQuery( '#' + edButtons[z].id ).attr( 'disabled', true );

		jQuery( '#ed_spell' ).attr( 'disabled', true );
		jQuery( '#ed_close' ).attr( 'disabled', true );

		/* check the writing in the textarea */
		proofread_bot.check('content', {
			success: function(errorCount) {
				if (errorCount == 0 && typeof callback === 'undefined')
					alert( proofread_bot.getLang('message_no_errors_found', 'No writing errors were found') );
				proofread_bot_restore_if_proofreading();
			},

			ready: function(errorCount) {
				jQuery('#ed_proofread_bot').attr('disabled', false);

				if( typeof callback !== 'undefined') 
					callback( errorCount );
			},

			error: function(reason) {
				jQuery('#ed_proofread_bot').attr('disabled', false);

				if( typeof callback !== 'undefined') 
					callback( -1 );
				else 
					alert( proofread_bot.getLang('message_server_error', 'There was a problem communicating with the After the Deadline service. Try again in one minute.') );

				proofread_bot_restore_if_proofreading();
			},

			editSelection: function(element) {
				var text = prompt( proofread_bot.getLang('dialog_replace_selection', 'Replace selection with:'), element.text() );

				if (text != null)
					element.replaceWith( text );
			}, 

			explain: function(url) {
				var left = (screen.width / 2) - (480 / 2);
				var top = (screen.height / 2) - (380 / 2);
				window.open( url, '', 'width=480,height=580,toolbar=0,status=0,resizable=0,location=0,menuBar=0,left=' + left + ',top=' + top).focus();
			},

			ignore: function(word) {
				jQuery.ajax({
					type : 'GET',
					url : proofread_bot.rpc_ignore + encodeURI( word ).replace( /&/g, '%26'),
					format : 'raw',
					error : function(XHR, status, error) {
						if (proofread_bot.callback_f != undefined && proofread_bot.callback_f.error != undefined)
							proofread_bot.callback_f.error(status + ": " + error);
					}
				});
			}
		});
	}
}
